'''provides an entry point for these functions from an ArcGIS 10 Toolbox'''

import arcpy
import local_vars
import funcs
import log
import script_tool_funcs

base_folder = script_tool_funcs.get_location()
log.initialize("opening for tbx_query_sources.py", arc_script=True)
local_vars.data_setup()


layer = arcpy.GetParameterAsText(0)
species = arcpy.GetParameterAsText(1)

species = script_tool_funcs.parse_input_species_from_list(species) # parse out the species code
zones = script_tool_funcs.zones_feature_to_array(layer)

db_cursor, db_conn = funcs.db_connect(local_vars.maindb, "Connecting to database to get source data for zones")

script_tool_funcs.query_datasets_by_zone(zones, db_conn, species)

funcs.db_close(db_cursor, db_conn)