__author__ = 'nrsantos'

import unittest
import subprocess
import sys
import os

from PISCES import local_vars
from PISCES import script_tool_funcs
from PISCES import log
from PISCES import mapping


class ReplaceVariablesTest(unittest.TestCase):

	def setup(self):
		script_tool_funcs.get_location()
		log.initialize(arc_script=True)
		local_vars.initialize()

	def test_dict_lookup(self):
		self.setup()
		self.assertIn("CMC01", local_vars.all_fish)
		print "success"
		self.setup()
		self.assertIn("CMC01", local_vars.all_fish)
		print "success"
		self.setup()
		self.assertIn("CMC01", local_vars.all_fish)
		print "success"
		self.setup()
		self.assertIn("CMC01", local_vars.all_fish)
		print "success"
		self.setup()
		self.assertIn("CMC01", local_vars.all_fish)
		# see note near main block below for why we do this many times in a row


		# All this code was because I thought that the test need to be run across multiple executions
		# turns out it stemmed from being run many times in the same execution
		#run_secondary_dict_lookup()
		#run_secondary_dict_lookup()

		#for i in range(1, 4):
		#	try:
		#		subprocess.check_call(["python", os.path.abspath(__file__)])
		#		print "Run %s times" % i
		#	except:
		#		print "FAILED"
		#		raise ValueError("Fish id is not in dictionary")


def run_secondary_dict_lookup():
	script_tool_funcs.get_location()
	log.initialize(arc_script=True)
	local_vars.initialize()

	if "alabaster" in local_vars.all_fish:
		print "EXCEPTION - lookup succeeded - 'alabaster' should not exist"
		sys.exit(1)

	if "CMC01" not in local_vars.all_fish:
		sys.exit(1)

	if len(local_vars.all_fish.keys()) == 0:
		sys.exit(1)

	try:
		mapping.begin("all", return_maps=True)  # run the maps and get the objects
	except:
		sys.exit(1)




if __name__ == "__main__":
	# If this script is invoked directly, then it means we're running the secondary tests
	# One issue that cropped up only appeared when something was run multiple times in a row.
	# To replicate better, we'll invoke this as a subprocess from a master in order to check

	run_secondary_dict_lookup()
	sys.exit(0)

	#results = unittest.TestResult()
	#loader = unittest.defaultTestLoader
	#test_suite = loader.loadTestsFromName('PISCES.tests.test_mapping.ReplaceVariablesTest.run_secondary_dict_lookup')
	#test_suite.run(results)
	#sys.exit(0)